//
//  DeeplinkManager.swift
//  Deliverable3
//
//  Created by Sneh Kothari on 01/11/22.
//

import Foundation

class DeeplinkManager {
    
    enum DeeplinkTarget: Equatable {
        case home
        case details(id: String)
    }
    
    class DeepLinkConstants {
        static let scheme = "deliverable3"
        static let host = "com.snehkothari"
        static let path = "/id"
        static let id = "id"
    }
    
    func manage(url: URL) -> DeeplinkTarget {
        guard url.scheme == DeepLinkConstants.scheme,
              url.host == DeepLinkConstants.host,
              url.path == DeepLinkConstants.path,
              let components = URLComponents(url: url, resolvingAgainstBaseURL: true),
              let queryItems = components.queryItems
        else {
            print("Error")
            return .home
        }
        
        let query = queryItems.reduce(into: [String: String]()) { (result, item) in
            result[item.name] = item.value
        }
        
        guard let id = query[DeepLinkConstants.id] else { return .home }

        return .details(id: id)
    }
}
