//
//  Deliverable3App.swift
//  Deliverable3
//
//  Created by Sneh Kothari on 29/10/22.
//

import SwiftUI

@main
struct Deliverable3App: App {
    @State var deeplinkTarget: DeeplinkManager.DeeplinkTarget?
    
    var body: some Scene {
        WindowGroup {
            Group {
                switch self.deeplinkTarget {
                case .home:
                    ContentView()
                case .details(let queryInfo):
                    DetailView(id: queryInfo)
                case .none:
                    ContentView()
                }
            }
            .onOpenURL{ url in
                    print(url)
                    let deepLinkManager = DeeplinkManager()
                    let link = deepLinkManager.manage(url: url)
                    self.deeplinkTarget = link
                }
        }
    }
}
